<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;v9jmyrpcwymx5d6inidy85x2ljzgm935-vendored-sources&#x2F;backtrace-0.3.64&#x2F;src&#x2F;lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../backtrace/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
</pre><pre class="rust"><code><span class="doccomment">//! A library for acquiring a backtrace at runtime</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This library is meant to supplement the `RUST_BACKTRACE=1` support of the</span>
<span class="doccomment">//! standard library by allowing an acquisition of a backtrace at runtime</span>
<span class="doccomment">//! programmatically. The backtraces generated by this library do not need to be</span>
<span class="doccomment">//! parsed, for example, and expose the functionality of multiple backend</span>
<span class="doccomment">//! implementations.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Usage</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! First, add this to your Cargo.toml</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```toml</span>
<span class="doccomment">//! [dependencies]</span>
<span class="doccomment">//! backtrace = &quot;0.3&quot;</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Next:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//! fn main() {</span>
<span class="doccomment">//! # // Unsafe here so test passes on no_std.</span>
<span class="doccomment">//! # #[cfg(feature = &quot;std&quot;)] {</span>
<span class="doccomment">//!     backtrace::trace(|frame| {</span>
<span class="doccomment">//!         let ip = frame.ip();</span>
<span class="doccomment">//!         let symbol_address = frame.symbol_address();</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!         // Resolve this instruction pointer to a symbol name</span>
<span class="doccomment">//!         backtrace::resolve_frame(frame, |symbol| {</span>
<span class="doccomment">//!             if let Some(name) = symbol.name() {</span>
<span class="doccomment">//!                 // ...</span>
<span class="doccomment">//!             }</span>
<span class="doccomment">//!             if let Some(filename) = symbol.filename() {</span>
<span class="doccomment">//!                 // ...</span>
<span class="doccomment">//!             }</span>
<span class="doccomment">//!         });</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!         true // keep going to the next frame</span>
<span class="doccomment">//!     });</span>
<span class="doccomment">//! }</span>
<span class="doccomment">//! # }</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Backtrace accuracy</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This crate implements best-effort attempts to get the native backtrace. This</span>
<span class="doccomment">//! is not always guaranteed to work, and some platforms don&#39;t return any</span>
<span class="doccomment">//! backtrace at all. If your application requires accurate backtraces then it&#39;s</span>
<span class="doccomment">//! recommended to closely evaluate this crate to see whether it&#39;s suitable</span>
<span class="doccomment">//! for your use case on your target platforms.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Even on supported platforms, there&#39;s a number of reasons that backtraces may</span>
<span class="doccomment">//! be less-than-accurate, including but not limited to:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * Unwind information may not be available. This crate primarily implements</span>
<span class="doccomment">//!   backtraces by unwinding the stack, but not all functions may have</span>
<span class="doccomment">//!   unwinding information (e.g. DWARF unwinding information).</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * Rust code may be compiled without unwinding information for some</span>
<span class="doccomment">//!   functions. This can also happen for Rust code compiled with</span>
<span class="doccomment">//!   `-Cpanic=abort`. You can remedy this, however, with</span>
<span class="doccomment">//!   `-Cforce-unwind-tables` as a compiler option.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * Unwind information may be inaccurate or corrupt. In the worst case</span>
<span class="doccomment">//!   inaccurate unwind information can lead this library to segfault. In the</span>
<span class="doccomment">//!   best case inaccurate information will result in a truncated stack trace.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * Backtraces may not report filenames/line numbers correctly due to missing</span>
<span class="doccomment">//!   or corrupt debug information. This won&#39;t lead to segfaults unlike corrupt</span>
<span class="doccomment">//!   unwinding information, but missing or malformed debug information will</span>
<span class="doccomment">//!   mean that filenames and line numbers will not be available. This may be</span>
<span class="doccomment">//!   because debug information wasn&#39;t generated by the compiler, or it&#39;s just</span>
<span class="doccomment">//!   missing on the filesystem.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * Not all platforms are supported. For example there&#39;s no way to get a</span>
<span class="doccomment">//!   backtrace on WebAssembly at the moment.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * Crate features may be disabled. Currently this crate supports using Gimli</span>
<span class="doccomment">//!   libbacktrace on non-Windows platforms for reading debuginfo for</span>
<span class="doccomment">//!   backtraces. If both crate features are disabled, however, then these</span>
<span class="doccomment">//!   platforms will generate a backtrace but be unable to generate symbols for</span>
<span class="doccomment">//!   it.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! In most standard workflows for most standard platforms you generally don&#39;t</span>
<span class="doccomment">//! need to worry about these caveats. We&#39;ll try to fix ones where we can over</span>
<span class="doccomment">//! time, but otherwise it&#39;s important to be aware of the limitations of</span>
<span class="doccomment">//! unwinding-based backtraces!</span>

<span class="attribute">#![<span class="ident">doc</span>(<span class="ident">html_root_url</span> <span class="op">=</span> <span class="string">&quot;https://docs.rs/backtrace&quot;</span>)]</span>
<span class="attribute">#![<span class="ident">deny</span>(<span class="ident">missing_docs</span>)]</span>
<span class="attribute">#![<span class="ident">no_std</span>]</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(
    <span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>, <span class="ident">target_env</span> <span class="op">=</span> <span class="string">&quot;sgx&quot;</span>, <span class="ident">target_vendor</span> <span class="op">=</span> <span class="string">&quot;fortanix&quot;</span>),
    <span class="ident">feature</span>(<span class="ident">sgx_platform</span>)
)]</span>
<span class="attribute">#![<span class="ident">warn</span>(<span class="ident">rust_2018_idioms</span>)]</span>
<span class="comment">// When we&#39;re building as part of libstd, silence all warnings since they&#39;re</span>
<span class="comment">// irrelevant as this crate is developed out-of-tree.</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">backtrace_in_libstd</span>, <span class="ident">allow</span>(<span class="ident">warnings</span>))]</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>), <span class="ident">allow</span>(<span class="ident">dead_code</span>))]</span>
<span class="comment">// We know this is deprecated, it&#39;s only here for back-compat reasons.</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;rustc-serialize&quot;</span>, <span class="ident">allow</span>(<span class="ident">deprecated</span>))]</span>

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">std</span>;

<span class="comment">// This is only used for gimli right now, which is only used on some platforms,</span>
<span class="comment">// so don&#39;t worry if it&#39;s unused in other configurations.</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused_extern_crates</span>)]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">alloc</span>;

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::backtrace</span>::{<span class="ident">trace_unsynchronized</span>, <span class="ident">Frame</span>};
<span class="kw">mod</span> <span class="ident">backtrace</span>;

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::symbolize::resolve_frame_unsynchronized</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::symbolize</span>::{<span class="ident">resolve_unsynchronized</span>, <span class="ident">Symbol</span>, <span class="ident">SymbolName</span>};
<span class="kw">mod</span> <span class="ident">symbolize</span>;

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::types::BytesOrWideString</span>;
<span class="kw">mod</span> <span class="ident">types</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::symbolize::clear_symbol_cache</span>;

<span class="kw">mod</span> <span class="ident">print</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">print</span>::{<span class="ident">BacktraceFmt</span>, <span class="ident">BacktraceFrameFmt</span>, <span class="ident">PrintFmt</span>};

<span class="macro">cfg_if::cfg_if!</span> {
    <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> {
        <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::backtrace::trace</span>;
        <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::symbolize</span>::{<span class="ident">resolve</span>, <span class="ident">resolve_frame</span>};
        <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::capture</span>::{<span class="ident">Backtrace</span>, <span class="ident">BacktraceFrame</span>, <span class="ident">BacktraceSymbol</span>};
        <span class="kw">mod</span> <span class="ident">capture</span>;
    }
}

<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
<span class="kw">struct</span> <span class="ident">Bomb</span> {
    <span class="ident">enabled</span>: <span class="ident">bool</span>,
}

<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
<span class="kw">impl</span> <span class="ident">Drop</span> <span class="kw">for</span> <span class="ident">Bomb</span> {
    <span class="kw">fn</span> <span class="ident">drop</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">enabled</span> {
            <span class="macro">panic!</span>(<span class="string">&quot;cannot panic during the backtrace function&quot;</span>);
        }
    }
}

<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">lock</span> {
    <span class="kw">use</span> <span class="ident">std::boxed::Box</span>;
    <span class="kw">use</span> <span class="ident">std::cell::Cell</span>;
    <span class="kw">use</span> <span class="ident">std::sync</span>::{<span class="ident">Mutex</span>, <span class="ident">MutexGuard</span>, <span class="ident">Once</span>};

    <span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">LockGuard</span>(<span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">MutexGuard</span><span class="op">&lt;</span><span class="lifetime">&#39;static</span>, ()<span class="op">&gt;</span><span class="op">&gt;</span>);

    <span class="kw">static</span> <span class="kw-2">mut</span> <span class="ident">LOCK</span>: <span class="kw-2">*</span><span class="kw-2">mut</span> <span class="ident">Mutex</span><span class="op">&lt;</span>()<span class="op">&gt;</span> <span class="op">=</span> <span class="number">0</span> <span class="kw">as</span> <span class="kw-2">*</span><span class="kw-2">mut</span> <span class="kw">_</span>;
    <span class="kw">static</span> <span class="ident">INIT</span>: <span class="ident">Once</span> <span class="op">=</span> <span class="ident">Once::new</span>();
    <span class="macro">thread_local!</span>(<span class="kw">static</span> <span class="ident">LOCK_HELD</span>: <span class="ident">Cell</span><span class="op">&lt;</span><span class="ident">bool</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">Cell::new</span>(<span class="bool-val">false</span>));

    <span class="kw">impl</span> <span class="ident">Drop</span> <span class="kw">for</span> <span class="ident">LockGuard</span> {
        <span class="kw">fn</span> <span class="ident">drop</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) {
            <span class="kw">if</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">is_some</span>() {
                <span class="ident">LOCK_HELD</span>.<span class="ident">with</span>(<span class="op">|</span><span class="ident">slot</span><span class="op">|</span> {
                    <span class="macro">assert!</span>(<span class="ident">slot</span>.<span class="ident">get</span>());
                    <span class="ident">slot</span>.<span class="ident">set</span>(<span class="bool-val">false</span>);
                });
            }
        }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">lock</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">LockGuard</span> {
        <span class="kw">if</span> <span class="ident">LOCK_HELD</span>.<span class="ident">with</span>(<span class="op">|</span><span class="ident">l</span><span class="op">|</span> <span class="ident">l</span>.<span class="ident">get</span>()) {
            <span class="kw">return</span> <span class="ident">LockGuard</span>(<span class="prelude-val">None</span>);
        }
        <span class="ident">LOCK_HELD</span>.<span class="ident">with</span>(<span class="op">|</span><span class="ident">s</span><span class="op">|</span> <span class="ident">s</span>.<span class="ident">set</span>(<span class="bool-val">true</span>));
        <span class="kw">unsafe</span> {
            <span class="ident">INIT</span>.<span class="ident">call_once</span>(<span class="op">|</span><span class="op">|</span> {
                <span class="ident">LOCK</span> <span class="op">=</span> <span class="ident">Box::into_raw</span>(<span class="ident">Box::new</span>(<span class="ident">Mutex::new</span>(())));
            });
            <span class="ident">LockGuard</span>(<span class="prelude-val">Some</span>((<span class="kw-2">*</span><span class="ident">LOCK</span>).<span class="ident">lock</span>().<span class="ident">unwrap</span>()))
        }
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">windows</span>, <span class="ident">not</span>(<span class="ident">target_vendor</span> <span class="op">=</span> <span class="string">&quot;uwp&quot;</span>)))]</span>
<span class="kw">mod</span> <span class="ident">dbghelp</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">windows</span>)]</span>
<span class="kw">mod</span> <span class="ident">windows</span>;
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="backtrace" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>